alias defender {
  unset %peers
  if ($sock(other_Defender)) sockclose other_Defender
  sockopen other_Defender $replace($iif($hget(defender,server),$v1,127.0.0.1:6667),:,$chr(32))
}

on *:SOCKOPEN:other_Defender: {
  var %s1 =  sockwrite -n $sockname
  %s1 USER $iif($hget(defender,name),$v1,Defender) $iif($hget(defender,name),$v1,Defender) $gettok($iif($hget(defender,server),$v1,127.0.0.1:6667),1,$asc(:)) :IRC Defender
  %s1 NICK $iif($hget(defender,name),$v1,Defender)
}

on *:SOCKREAD:other_Defender: {
  sockread %def | tokenize 32 %def

  var %s1 =  sockwrite -n $sockname

  if ($2-3 == MODE $iif($hget(defender,name),$v1,Defender)) %s1 oper $iif($hget(defender,oper),$v1,Services) $iif($hget(defender,pass),$v1,123456)
  if ($8-9 == IRC operator) {
    %s1 MODE $iif($hget(defender,name),$v1,Defender) -Mmn+SF
    %s1 VHOST $iif($hget(defender,name),$v1,Defender) $+(Services.,$readsettings(permissions,network))
    if ($hget(defender,room)) {
      %s1 JOIN $hget(defender,room)
      %s1 MODE $hget(defender,room) $iif($hget(defender,mode),$v1,+Os)
    }
  }
  if ($2-3 == NOTICE AUTH) && ($7 == connected) {
    var %nick = $gettok($4,1,$asc(:))
    if ($hget(defender,flood) isnum) {
      inc %peers
      .timer -i 1 60 dec %peers
      if (%peers >= $hget(defender,flood)) %s1 kill %nick Server is being flood
    }
    %s1 privmsg %nick :VERSION
    %s1 SNOTICE %nick *** Checking for proxies...
    dns_stuff %nick
  }
  if ($2 == NOTICE) && (*VERSION iswm $4) {
    if (!$6) && ($hget(defender,word) == 1) %s1 kill %nick Your VERSION-reply is known as a trojan.
    if (*mIRC* iswm $5-) && ($hget(defender,mirc) == 1) {
      var %v = $wildtok($5-,v6.*,1,32)
      if (%v) {
        var %v = $remove(%v,v)
        if (%v <= 6.12) %s1 kill %nick Your mIRC version is known as insecure. We recommend to update it on www.mirc.com
      }
    }
  }
}


dialog Defender {
  size -1 -1 339 310
  icon package.ico, 0
  title "Defender"
  text "Nickname:",1,167 20 50 17
  text "Channel modes:",2,177 73 81 17
  text "connections/minute",3,220 171 97 17
  list 4,7 7 124 292,extsel size
  check "Autojoin:",5,156 45 65 20
  edit "#Services",6,234 46 82 20, autohs
  edit "Defender",7,234 19 82 20, autohs
  edit "+Os",8,266 72 50 20, autohs
  check "Ban single word VERSION",9,156 99 142 20
  check "Kill users with mIRC 6.0 to 6.12",10,156 123 177 20
  check "Block connecting when:",11,156 148 134 20
  edit "20",12,183 169 33 20, autohs
  list 13,203 274 66 30, size 
  edit "Name",15,234 192 82 20, autohs
  edit "Pass",16,234 214 82 20, autohs pass
  text "Oper Login:",14,163 195 58 17
  text "Server:",17,183 241 42 17
  edit "127.0.0.1:6667",18,234 238 82 20, autohs
}

on *:dialog:Defender:*:*: {
  if ($devent == init) {
    mdxinit
    mdx SetControlMDX $dname 4 ListView report rowselect single grid headerdrag > $views
    did -i $dname 4 1 headerdims 120
    did -i $dname 4 1 headertext DNSBL

    mdx SetControlMDX $dname 13 ToolBar arrows nodivider wrap list flat > $bars
    mdx SetFont $dname 13 -11 700 Tahoma
    mdx SetBorderStyle $dname 13
    did -i $dname 13 1 bmpsize 16 16
    did -i $dname 13 1 setimage 0 icon small $+($scriptdir,icon\disk.ico)
    did -a $dname 13 +a 1 Save $chr(9) Save your settings
    did $iif($hget(defender,room),-c,-u) $dname 5
    did $iif($hget(defender,room),-ar $dname 6 $hget(defender,room),-b $dname 6)
    did -ar $dname 7 $hget(defender,name)
    did $iif($hget(defender,room),-ar $dname 8 $hget(defender,mode),-b $dname 8)
    did $iif($hget(defender,word) == 1,-c,-u) $dname 9
    did $iif($hget(defender,mirc) == 1,-c,-u) $dname 10
    did $iif($hget(defender,flood),-c,-u) $dname 11
    did $iif($hget(defender,flood),-ar,-b) $dname 12 $hget(defender,flood)
    did -ar $dname 18 $hget(defender,server)
    did -ar $dname 15 $hget(defender,oper)
    did -ar $dname 16 $hget(defender,pass)
    var %a = 1
    while (%a <= $line(@dnsbl,0)) {
      did -a $dname 4 $line(@dnsbl,%a)
      inc %a
    }
  }

  if ($devent == sclick) {
    if ($did == 4) && (rclick * iswm $did(4,1)) def_menu defender
    if ($did == 5) did $iif($did(5).state == 1,-e,-b) $dname 6,8
    if ($did == 11) did $iif($did(11).state == 1,-e,-b) $dname 12
    if ($did == 13) {
      var %h = hadd -m defender
      %h name $did(7)
      %h oper $did(15)
      %h pass $did(16)
      %h word $did(9).state
      %h mirc $did(10).state
      %h server $did(18)
      if ($did(11).state == 1) %h flood $did(12)
      if ($did(5).state == 1) { %h room $did(6) | %h mode $did(8) }
      var %a = 2
      if ($window(@dnsbl)) clear @dnsbl
      else window -ahn @dnsbl
      while (%a <= $did(4).lines) {
        echo @dnsbl $gettok($did(4,%a),6,32)
        inc %a
      }
    }
  }
}

alias def_menu {
  if ($1 == defender) {
    var %a = $mpdll(MPCreateMenu,$1)
    mpcolors $1
    var %h = $gettok(%a,2,32)
    var %b = 1
    while (%b <= $findfile($qt($+($scriptdir,icon\popup\)),*.ico,0)) {
      var %a = $mpdll(MPAddIcon, $1 > $findfile($qt($+($scriptdir,icon\popup\)),*.ico,%b) > 0)
      inc %b
    }
    var %a = $mpdll(MPAddItem, %h > 1 13 0 $chr(160) Add DNSBL > /def_menu 1)
    var %a = $mpdll(MPAddItem, %h > 2 15 $iif($did(Defender,4).seltext,0,1) $chr(160) Remove selected > /def_menu 2)
    var %a = $mpdll(MPAddItem, %h > 3 15 0 $chr(160) Remove everything > /def_menu 3)
    var %a = $mpdll(MPopup, $1 > $mouse.dx $mouse.dy left top right)
  }
  if ($1 == 1) { 
    var %dnsbl = $input(Enter your DNSBL,eoqs,DNSBL)
    if (%dnsbl) did -a Defender 4 %dnsbl
  }
  if ($1 == 2) {
    var %a = 2
    while (%a <= $did(Defender,4).lines) {
      if (+*s* iswm $gettok($did(Defender,4,%a),2,32)) did -d Defender 4 %a
      else inc %a
    }
  }
  if ($1 == 3) did -r Defender 4
}

alias dns_stuff {
  var %ip = $ninf($1,ip)
  var %s1 = sockwrite -n other_defender
  if (!$ninf($1,ip)) { %s1 kill $1 Problems with resolving your IP. Try to reconnect. | return }
  if (!$window(@queue)) window -anh @queue
  if ($fline(@queue,%ip *,1)) {
    if ($fline(@queue,%ip @OK,1)) { .timer 1 3 %s1 snotice $1 *** No proxy found | return }
    if ($fline(@queue,%ip @BAD,1)) { %s1 kill $1 Blacklisted: Proxy found | return }
    else rline @queue $fline(@queue,%ip *,1) $line(@queue,$fline(@queue,%ip *,1)) $1
    return
  }
  else {
    echo @queue %ip $1
    .dns $+($ip_rev(%ip),.,$line(@dnsbl,1))
  }
}

alias ip_rev return $+($gettok($1,4,$asc(.)),.,$gettok($1,3,$asc(.)),.,$gettok($1,2,$asc(.)),.,$gettok($1,1,$asc(.)))


on *:DNS: {
  var %dnsbl = $gettok($dns(0).addr,5-7,$asc(.))
  var %s1 = sockwrite -n other_defender

  ;; DNSBL
  if ($fline(@dnsbl,%dnsbl,1)) {
    var %ip = $ip_rev($gettok($dns(0).addr,1-4,$asc(.)))

    ;; DNSBL -> Nothing found
    if ($dns(0) == 0) {
      var %nr = $fline(@dnsbl,%dnsbl,1)

      ;; DNSBL -> Nothing found -> All DNSBL checked
      if (%nr == $line(@dnsbl,0)) {
        var %nr = $fline(@queue,%ip *,1)
        var %nicks = $gettok($line(@queue,%nr),2-,32)
        var %a = 1
        while (%a <= $numtok(%nicks,32)) {
          %s1 snotice $gettok(%nicks,%a,32) *** No proxy found
          inc %a
        }
        rline @queue %nr %ip @OK
        return
      }

      ;; DNSBL -> Nothing found -> Next DNSBL
      else .dns $+($ip_rev(%ip),.,$line(@dnsbl,$calc(%nr + 1)))
    }

    ;; DNSBL -> Proxy found
    else {
      bladd %ip
      var %nr = $fline(@queue,%ip *,1)
      var %nicks = $gettok($line(@queue,%nr),2-,32)
      var %a = 1
      while (%a <= $numtok(%nicks,32)) {
        %s1 kill $gettok(%nicks,%a,32) Blacklisted: Proxy found
        %s1 privmsg $hget(defender,room) $+(:,Proxy found: $gettok(%nicks,%a,32))
        inc %a
      }
      rline @queue %nr %ip @BAD
      return
    }
  }
}

dialog globalsettings {
  size -1 -1 446 215
  title "Global"
  icon package.ico, 0
  text "Nickname:",1,22 13 50 17
  text "Oper Login:",2,15 42 59 17
  text "Server:",3,34 95 38 17
  text "Channel modes:",4,21 163 83 17
  edit "Global",5,88 12 80 20, autohs
  edit "Name",6,88 39 80 20, autohs
  edit "Pass",7,88 64 80 20, autohs pass
  edit "127.0.0.1:6667",8,88 95 80 20, autohs
  check "Autojoin:",9,9 133 70 20
  edit "#Services",10,88 134 80 20, autohs
  edit "+Os",11,106 160 62 20, autohs
  list 12,177 12 265 168,extsel size
  list 13,177 185 70 25, size 
}

on *:dialog:globalsettings:*:*: {
  if ($devent == init) {
    mdxinit
    mdx SetControlMDX $dname 12 ListView report rowselect grid headerdrag > $views
    did -i $dname 12 1 headerdims 180 80
    did -i $dname 12 1 headertext Message $chr(9) Expires on
    mdx SetControlMDX $dname 13 ToolBar arrows nodivider wrap list flat > $bars
    mdx SetFont $dname 13 -11 700 Tahoma
    mdx SetBorderStyle $dname 13
    did -i $dname 13 1 bmpsize 16 16
    did -i $dname 13 1 setimage 0 icon small $+($scriptdir,icon\disk.ico)
    did -a $dname 13 +a 1 Save $chr(9) Save your settings
    did -ar $dname 5 $hget(global,nick)
    did -ar $dname 6 $hget(global,name)
    did -ar $dname 7 $hget(global,pass)
    did -ar $dname 8 $hget(global,server)
    did $iif($hget(global,autojoin) == 1,-c,-u) $dname 9
    did $iif($hget(global,autojoin) == 1,-e,-b) $dname 10,11
    did -ar $dname 10 $hget(global,room)
    did -ar $dname 11 $hget(global,mode)
    var %a = 1
    while (%a <= $line(@global,0)) {
      did -a $dname 12 $line(@global,%a)
      inc %a
    }
  }
  if ($devent == sclick) {
    if ($did == 9) did $iif($did(9).state == 1,-e,-b) $dname 10,11
    if ($did == 12) && (rclick * iswm $did(12,1)) glob_menu global
    if ($did == 13) {
      var %h = hadd -m global
      %h nick $did(5)
      %h name $did(6)
      %h pass $did(7)
      %h server $did(8)
      %h autojoin $did(9).state
      %h room $did(10)
      %h mode $did(11)

      var %a = 2
      if ($window(@global)) clear @global
      else window -ahn @global
      while (%a <= $did(12).lines) {
        echo @global $+($gettok($gettok($did(12,%a),1,9),6-,32),$chr(9),$gettok($gettok($did(12,%a),2,9),5-,32))
        inc %a
      }
    }
  }
}

dialog addmessage {
  title "Add Message"
  icon package.ico, 0
  size -1 -1 237 167
  text "Message:", 1, 17 10 50 16, right
  edit "Message", 2, 76 7 155 21, autohs
  text "Expires on:", 3, 8 34 59 16, right
  radio "Never", 4, 48 57 51 20
  radio "On:", 5, 48 82 40 20
  edit "DD", 6, 89 80 27 21
  edit "MM", 7, 127 80 31 21
  edit "YYYY", 8, 169 80 37 21
  text "/", 9, 117 82 9 16
  text "/", 10, 159 82 9 16
  edit "HH", 11, 113 107 27 21
  text ":", 12, 141 109 6 16
  edit "nn", 13, 150 107 27 21
  list 14, 67 135 100 26, size
}

on *:DIALOG:addmessage:*:*: {
  if ($devent == init) {
    mdxinit
    mdx SetControlMDX $dname 14 ToolBar arrows nodivider wrap list flat > $bars
    mdx SetFont $dname 14 -11 700 Tahoma
    mdx SetBorderStyle $dname 14
    did -i $dname 14 1 bmpsize 16 16
    did -i $dname 14 1 setimage 0 icon small $+($scriptdir,icon\disk.ico)
    did -a $dname 14 +a 1 Save $chr(9) Save your message
  }

  if ($devent == sclick) {
    if ($did == 5) || ($did == 4) did $iif($did(5).state == 1,-e,-b) $dname 6-8,11,13
    if ($did == 14) {
      did -a globalsettings 12 $did(2) $chr(9) $iif($did(4).state == 1,Never,$+($did(6),/,$did(7),/,$did(8),$chr(32),$did(11),:,$did(13)))
      dialog -x $dname $dname
    }
  }
}

alias glob_menu {
  if ($1 == global) {
    var %a = $mpdll(MPCreateMenu,$1)
    mpcolors $1
    var %h = $gettok(%a,2,32)
    var %b = 1
    while (%b <= $findfile($qt($+($scriptdir,icon\popup\)),*.ico,0)) {
      var %a = $mpdll(MPAddIcon, $1 > $findfile($qt($+($scriptdir,icon\popup\)),*.ico,%b) > 0)
      inc %b
    }
    var %a = $mpdll(MPAddItem, %h > 1 13 0 $chr(160) Add Message > /glob_menu 1)
    var %a = $mpdll(MPAddItem, %h > 2 15 $iif($did(globalsettings,12).seltext,0,1) $chr(160) Remove selected > /glob_menu 2)
    var %a = $mpdll(MPAddItem, %h > 3 15 0 $chr(160) Remove everything > /glob_menu 3)
    var %a = $mpdll(MPopup, $1 > $mouse.dx $mouse.dy left top right)
  }
  if ($1 == 1) noop $dialog(addmessage,addmessage)
  if ($1 == 2) {
    var %a = 2
    while (%a <= $did(globalsettings,12).lines) {
      if (+*s* iswm $gettok($did(globalsettings,12,%a),2,32)) did -d globalsettings 12 %a
      else inc %a
    }
  }
  if ($1 == 3) did -r globalsettings 12
}


on *:SOCKOPEN:other_global: {
  var %s1 =  sockwrite -n $sockname
  %s1 NICK $iif($hget(global,nick),$v1,Global)
  %s1 USER $iif($hget(global,nick),$v1,Global) $iif($hget(global,nick),$v1,Global) $qt($gettok($iif($hget(global,server),$v1,127.0.0.1:6667),1,$asc(:))) :Global
}

on *:SOCKREAD:other_global: {
  sockread %global | tokenize 32 %global
  var %s1 =  sockwrite -n $sockname

  if ($2-3 == MODE $iif($hget(global,nick),$v1,Global)) %s1 oper $iif($hget(global,name),$v1,Services) $iif($hget(global,pass),$v1,123456)
  if ($8-9 == IRC operator) {
    %s1 MODE $iif($hget(global,nick),$v1,Global) -Mmn+SF
    %s1 VHOST $iif($hget(global,nick),$v1,Global) $+(Services.,$readsettings(permissions,network))
    if ($hget(global,room)) {
      %s1 JOIN $hget(global,room)
      %s1 MODE $hget(global,room) $iif($hget(global,mode),$v1,+Os)
    }
  }
  if ($2-3 == NOTICE AUTH) && ($7 == connected) {
    var %nick = $gettok($4,1,$asc(:))
    var %a = 1
    while (%a <= $line(@global,0)) {
      if ($gettok($line(@global,%a),2,9) == Never) %s1 notice %nick $gettok($line(@global,%a),1,9)
      elseif ($ctime($gettok($line(@global,%a),2,9)) > $ctime) %s1 notice %nick $gettok($line(@global,%a),1,9)
      else dline @global %a
      inc %a
    }
  }
}

alias global_start {
  if ($sock(other_Global)) sockclose other_Global
  sockopen other_Global $replace($iif($hget(global,server),$v1,127.0.0.1:6667),:,$chr(32))
}

alias global_add {
  if ($istokcs($ninf($1,mod),S,32) == $false) prs $1 481 $1 :Permission Denied- This function is for Services (+S) only
  elseif (!$3) prs $1 461 $1 $2 :Not enough parameters
  else {
    var %a = 1
    while (%a <= $userss(0)) {
      sockwrite -n other_global notice $userss(%a) $3-
      inc %a
    }
  }
}




on *:START: { 
  hmake defender 10
  hload -i defender $qt($+($scriptdir,settings\defender.dat))
  window -ahn @dnsbl
  loadbuf @dnsbl $qt($+($scriptdir,settings\dnsbl.txt))

  hmake global 10
  hload -i global $qt($+($scriptdir,settings\global.dat))
  window -ahn @global
  loadbuf @global $qt($+($scriptdir,settings\messages.txt))
}

on *:EXIT: {
  hsave -i defender $qt($+($scriptdir,settings\defender.dat))
  savebuf @dnsbl $qt($+($scriptdir,settings\dnsbl.txt))

  hsave -i global $qt($+($scriptdir,settings\global.dat))
  savebuf @global $qt($+($scriptdir,settings\messages.txt))
}

on *:LOAD: {
  var %write = plug Defender
  %write name Defender
  %write version 1.0.0
  %write owner Miyako
  %write start defender
  %write stop sockclose other_Defender
  %write settings dialog -m Defender Defender

  var %write = plug Global
  %write name Global
  %write version 1.0.0
  %write owner Miyako
  %write start global_start
  %write stop sockclose other_Global
  %write settings dialog -m globalsettings globalsettings
  cmds global global_add
}

on *:UNLOAD: {
  plug Defender
  plug Global
  cmds global
}
